require "weakref"

require "chainer/version"

require 'chainer/cuda'
require 'chainer/backend'
require 'chainer/configuration'
require 'chainer/device'
require 'chainer/function'
require 'chainer/function_node'
require 'chainer/optimizer'
require 'chainer/gradient_method'
require 'chainer/gradient_check'
require 'chainer/hyperparameter'
require 'chainer/dataset/iterator'
require 'chainer/dataset/convert'
require 'chainer/initializer'
require 'chainer/initializers/init'
require 'chainer/initializers/constant'
require 'chainer/initializers/normal'
require 'chainer/initializers/uniform'
require 'chainer/iterators/serial_iterator'
require 'chainer/link'
require 'chainer/links/connection/convolution_2d'
require 'chainer/links/connection/embed_id'
require 'chainer/links/connection/linear'
require 'chainer/links/normalization/batch_normalization'
require 'chainer/links/model/classifier'
require 'chainer/variable'
require 'chainer/variable_node'
require 'chainer/utils/conv'
require 'chainer/utils/initializer'
require 'chainer/utils/math'
require 'chainer/utils/variable'
require 'chainer/utils/array'
require 'chainer/functions/activation/leaky_relu'
require 'chainer/functions/activation/relu'
require 'chainer/functions/activation/relu_grad2'
require 'chainer/functions/activation/sigmoid'
require 'chainer/functions/activation/sigmoid_grad'
require 'chainer/functions/activation/tanh'
require 'chainer/functions/activation/log_softmax'
require 'chainer/functions/array/broadcast_to'
require 'chainer/functions/array/cast'
require 'chainer/functions/array/reshape'
require 'chainer/functions/array/rollaxis'
require 'chainer/functions/array/select_item'
require 'chainer/functions/array/squeeze'
require 'chainer/functions/array/transpose'
require 'chainer/functions/evaluation/accuracy'
require 'chainer/functions/math/basic_math'
require 'chainer/functions/math/identity'
require 'chainer/functions/math/sum'
require 'chainer/functions/math/exp'
require 'chainer/functions/loss/mean_squared_error'
require 'chainer/functions/loss/softmax_cross_entropy'
require 'chainer/functions/connection/convolution_2d'
require 'chainer/functions/connection/deconvolution_2d'
require 'chainer/functions/connection/convolution_2d_grad_w'
require 'chainer/functions/connection/embed_id'
require 'chainer/functions/connection/linear'
require 'chainer/functions/noise/dropout'
require 'chainer/functions/normalization/batch_normalization'
require 'chainer/functions/pooling/pooling_2d'
require 'chainer/functions/pooling/average_pooling_2d'
require 'chainer/functions/pooling/max_pooling_2d'
require 'chainer/testing/array'
require 'chainer/training/extension'
require 'chainer/training/extensions/evaluator'
require 'chainer/training/extensions/exponential_shift'
require 'chainer/training/extensions/log_report'
require 'chainer/training/extensions/print_report'
require 'chainer/training/extensions/progress_bar'
require 'chainer/training/extensions/snapshot'
require 'chainer/training/trainer'
require 'chainer/training/updater'
require 'chainer/training/util'
require 'chainer/training/standard_updater'
require 'chainer/training/triggers/interval'
require 'chainer/parameter'
require 'chainer/optimizers/adam'
require 'chainer/optimizers/momentum_sgd'
require 'chainer/datasets/mnist'
require 'chainer/datasets/cifar'
require 'chainer/datasets/tuple_dataset'
require 'chainer/reporter'
require 'chainer/serializer'
require 'chainer/serializers/marshal'

require 'numo/narray'

module Chainer
  def self.configure
    yield(configuration)
  end

  def self.configuration
    @configuration ||= Configuration.new
  end
end

